/*!
 * wbm-runtime-configuration@1.0.0
 * 
 *   Copyright © 2019 WAGO Kontakttechnik GmbH & Co. KG
 * 
 *   License: 
 *     WAGO Software License Agreement
 * 
 *   Contributors:
 *     
 * 
 *   Description:
 *     e!RUNTIME Configuration options
 * 
 *   
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports["runtime-configuration"]=t():e["runtime-configuration"]=t()}(this,function(){return function(e){function t(n){if(r[n])return r[n].exports;var i=r[n]={i:n,l:!1,exports:{}};return e[n].call(i.exports,i,i.exports,t),i.l=!0,i.exports}var r={};return t.m=e,t.c=r,t.d=function(e,r,n){t.o(e,r)||Object.defineProperty(e,r,{configurable:!1,enumerable:!0,get:n})},t.n=function(e){var r=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(r,"a",r),r},t.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},t.p="",t(t.s=0)}([function(e,t,r){"use strict";function n(e){return i(this,void 0,void 0,function(){var t,n,a=this;return o(this,function(l){return t=function(t,r,n){return i(a,void 0,void 0,function(){var t,i;return o(this,function(o){switch(o.label){case 0:return r==n||null==n?[3,2]:(console.log("new=",r,"old=",n),[4,e.parameter.execute("webserver.restart")]);case 1:t=o.sent(),i=t.error,i&&861!==i.statusCode&&e.modalPresenter.showErrorDialog(e,{title:e.localization.localized({key:"webserver-did-not-restart-error-modal-title",fallback:"Webserver restart failed"}),message:e.localization.localized({key:"webserver-did-not-restart-error-modal-message",fallback:"A webserver restart is required for changes to take effect but failed."}),detailMessage:i.message}),o.label=2;case 2:return[2]}})})},n={kind:"change",throttleTime:0},e.parameter.observe("webserver.default",n,t),e.parameter.observe("runtime.version",n,t),[2,{id:"runtime-configuration",title:{fallback:"PLC Runtime",key:"plc-runtime-menu-title"},priority:1e3,controller:e.viewGenerator.generate(e,r(1))}]})})}var i=this&&this.__awaiter||function(e,t,r,n){return new(r||(r=Promise))(function(i,o){function a(e){try{u(n.next(e))}catch(e){o(e)}}function l(e){try{u(n.throw(e))}catch(e){o(e)}}function u(e){e.done?i(e.value):new r(function(t){t(e.value)}).then(a,l)}u((n=n.apply(e,t||[])).next())})},o=this&&this.__generator||function(e,t){function r(e){return function(t){return n([e,t])}}function n(r){if(i)throw new TypeError("Generator is already executing.");for(;u;)try{if(i=1,o&&(a=2&r[0]?o.return:r[0]?o.throw||((a=o.return)&&a.call(o),0):o.next)&&!(a=a.call(o,r[1])).done)return a;switch(o=0,a&&(r=[2&r[0],a.value]),r[0]){case 0:case 1:a=r;break;case 4:return u.label++,{value:r[1],done:!1};case 5:u.label++,o=r[1],r=[0];continue;case 7:r=u.ops.pop(),u.trys.pop();continue;default:if(a=u.trys,!(a=a.length>0&&a[a.length-1])&&(6===r[0]||2===r[0])){u=0;continue}if(3===r[0]&&(!a||r[1]>a[0]&&r[1]<a[3])){u.label=r[1];break}if(6===r[0]&&u.label<a[1]){u.label=a[1],a=r;break}if(a&&u.label<a[2]){u.label=a[2],u.ops.push(r);break}a[2]&&u.ops.pop(),u.trys.pop();continue}r=t.call(e,u)}catch(e){r=[6,e],o=0}finally{i=a=0}if(5&r[0])throw r[1];return{value:r[0]?r[1]:void 0,done:!0}}var i,o,a,l,u={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return l={next:r(0),throw:r(1),return:r(2)},"function"==typeof Symbol&&(l[Symbol.iterator]=function(){return this}),l};Object.defineProperty(t,"__esModule",{value:!0}),base.plugin.register("wbm-runtime-configuration",n)},function(e,t){e.exports={title:{default:"PLC Runtime Configuration",localized:"plc-runtime-configuration-page-title"},note:{default:"Changes will take effect immediately.",localized:"plc-runtime-configuration-page-note"},content:[{title:{default:"General PLC Runtime Configuration",localized:"runtime-configuration-runtime-form-title"},note:{default:"Note: All data of the currently running runtime system will be deleted. Same function as Reset (origin).\n\nChanging home directory for the PLC boot project will take effect after the next controller reboot.\nA Reset (origin) is required prior to submit a change.",localized:"runtime-configuration-runtime-form-note"},sections:[{fields:[{title:{default:"PLC Runtime Version",localized:"runtime-configuration-runtime-version-field-title"},parameter:"runtime.version",control:{type:"dropdown",items:[{repeat:"runtime.availableversions.*.id",value:"${runtime.availableversions.*.id}",title:{localized:"${runtime.availableversions.*.id}-dropdown-item",default:"${runtime.availableversions.*.name}"}}]}},{title:{default:"Home directory on memory card enabled",localized:"runtime-configuration-home-directory-on-memory-card-field-title"},parameter:"runtime.homedirectoryonmemorycard",control:{type:"checkbox"}}]}]},{title:{default:"Webserver Configuration",localized:"runtime-configuration-webserver-form-title"},note:{default:'Note: The WebVisu is not available, if the corresponding webserver is disabled. The state can be configured on "Ports and Services - PLC Runtime Services" page.',localized:"runtime-information-webvisu-form-note"},sections:[{fields:[{title:{default:"CODESYS 2 Webserver State",localized:"runtime-configuration-codesys-2-webserver-state-field-title"},parameter:"runtime.codesys2.webserver.state",hidden:"runtime.codesys2.available is false",control:{type:"checkbox"},options:{readonly:!0}},{title:{default:"e!RUNTIME Webserver State",localized:"runtime-configuration-eruntime-webserver-state-field-title"},parameter:"runtime.eruntime.webserver.state",hidden:"runtime.eruntime.available is false",control:{type:"checkbox"},options:{readonly:!0}},{title:{default:"Default Webserver",localized:"runtime-configuration-default-webserver-field-title"},parameter:"webserver.default",control:{type:"dropdown",items:[{title:{default:"Web-based Management",localized:"default-webserver-web-based-management-dropdown-item"},value:"WBM"},{title:{default:"WebVisu",localized:"default-webserver-webvisu-dropdown-item"},value:"Webvisu"}]}}]}]}]}}])});
//# sourceMappingURL=runtime-configuration.js.map